#ifndef WELL_MODELS_HH
#define WELL_MODELS_HH

#include "Vector.hh"
#include "CImg.h"
#include "grid.hh"

// A Postprocessing class representing the well pipe by conductivity
// coefficients in the ConductivityCoefficients class
class WellPostProcessor
{
private:
  const Vector begin;
  const Vector end;
  const double K;
public:
  
  WellPostProcessor(
					Vector _begin
					, Vector _end
					, double _K 
					) : begin(_begin), end(_end), K(_K)
  {}

  void process(const Grid & grid, SpatialParameters & parameters) const
  {
	// TODO: INSERT YOUR CODE HERE TO MODIFY THE CONDUCTIVITY FIELD DIRECTLY (MODEL 3):

  }
};

// A dummy post processor for ConductivityCoefficients
class NoPostProcessing
{
private:
public:
  
  NoPostProcessing(Vector , Vector , double)
  {}

  void process(SpatialParameters &) const
  {
  }
};

class WellAdaptiveSources : public Sources
{
private:
  const SpatialParameters & conductivity;
  const double total_source_value;
  double norm_factor;
  double cellvolume;
  const Vector begin;
  const Vector end;
public:

  WellAdaptiveSources(const Grid & grid, 
					  const double _total_source_value,
					  const Vector _begin, 
					  const Vector _end, 
					  const SpatialParameters & _conductivity)
    : conductivity(_conductivity),
      total_source_value(_total_source_value),
      norm_factor(0),
      begin(_begin), 
	  end(_end)
  {
	// TODO: INSERT YOUR CODE HERE TO DO THE INITIALIZATION STEPS FOR MODEL 2:
	// INITIALIZATION STEPS = THINGS THAT NEED TO BE DONE ONLY ONCE


  } // constructor



  virtual double operator()(const Vector & center) const
  {
	// TODO: INSERT YOUR CODE HERE TO CALCULATE THE SOURCE TERM FOR MODEL 2:
    
    return 0;
  }
};





class WellConstantSources : public Sources
{
private:
  const double total_source_value;
  double norm_factor;
  double cellvolume;
  const Vector begin;
  const Vector end;
public:

  WellConstantSources( const Grid & grid, 
					   const double _total_source_value,
					   const Vector _begin, 
					   const Vector _end
					   )
    : total_source_value(_total_source_value),
      norm_factor(0),
      begin(_begin), 
	  end(_end)
  {
	// TODO: INSERT YOUR CODE HERE TO DO THE INITIALIZATION STEPS FOR MODEL 1:
	// INITIALIZATION STEPS = THINGS THAT NEED TO BE DONE ONLY ONCE

  } // constructor
  
  virtual double operator()(const Vector & center) const
  {
	// TODO: INSERT YOUR CODE HERE TO CALCULATE THE SOURCE TERM FOR MODEL 1:
    
    return 0;
  }
};

#endif //WELL_MODELS_HH
